<template>
    <div class="wrapper">
        <md-toolbar class="md-dense md-red toolbar-heigth">
            <h3 class="ml-8  md-title text-align-left text-white">
                <md-icon class="text-white">collections</md-icon>
                COLECCIONES
            </h3>
        </md-toolbar>
        <div class="md-layout md-alignment-top-center">
            <div class="md-layout-item md-size-70 md-small-size-100">
                <md-card>
                    <md-card-area>
                        <!-- <md-card-header>
                        Listado de colecciones
                    </md-card-header> -->
                        <md-card-content class="mt-3">
                            <!-- <div class="md-layout"> -->
                            <div class="md-layout-item">
                                <div class="md-layout" >
                                    <div class="md-layout-item">
                                        <h3>Listado de colecciones</h3>
                                    </div>
                                    <div class="md-layout-item ">
                                        <md-button class="md-raised md-primary right"
                                        to="/publicar-coleccion"
                                            >Crear colección</md-button
                                        >
                                    </div>
                                </div>
                            </div>

                            <!-- </div> -->

                            <div v-if="collections && collections.length > 0">
                                <div class="md-layout-item">
                                    <md-table
                                        v-model="searched"
                                        md-sort="id"
                                        md-sort-order="desc"
                                        md-card
                                        md-fixed-header
                                    >
                                        <md-table-toolbar>
                                            <div class="md-layout">
                                                <!-- <div class="md-layout-item">
                                                    <md-button
                                                        class="md-dense md-raised md-primary"
                                                        >Excel</md-button
                                                    >
                                                    <md-button
                                                        class="md-dense md-raised md-primary"
                                                        >PDF</md-button
                                                    >
                                                </div> -->
                                                <div class="md-layout-item">
                                                    <md-field>
                                                        <md-input
                                                            @input="
                                                                searchOnTable
                                                            "
                                                            v-model="search"
                                                            placeholder="Escribe título"
                                                            required
                                                        ></md-input>
                                                        <span class="md-error"
                                                            >Ingrese un
                                                            título</span
                                                        >
                                                    </md-field>
                                                </div>
                                            </div>
                                            <!-- <h1 class="md-title">Colecciones</h1> -->
                                        </md-table-toolbar>

                                        <md-table-row
                                            slot="md-table-row"
                                            slot-scope="{ item }"
                                        >
                                            <md-table-cell
                                                md-label="Id"
                                                md-sort-by="id"
                                                md-numeric
                                                >{{ item.id }}</md-table-cell
                                            >
                                            <md-table-cell
                                                md-label="Título"
                                                md-sort-by="label"
                                                >{{ item.label }}</md-table-cell
                                            >
                                            <md-table-cell
                                                md-label="Categorías"
                                                >{{
                                                    item.categories
                                                        ? item.categories
                                                              .map(m => m.label)
                                                              .join(", ")
                                                        : ""
                                                }}</md-table-cell
                                            >
                                            <md-table-cell md-label="Autor">{{
                                                user.username
                                            }}</md-table-cell>
                                            <md-table-cell md-label="Accciones">
                                                <md-button
                                                    :to="{
                                                        name:
                                                            'collection-detail',
                                                        params: {
                                                            id: item.id
                                                        }
                                                    }"
                                                >
                                                    <md-icon
                                                        >remove_red_eye</md-icon
                                                    >
                                                    <span>Ver</span>
                                                </md-button>
                                                <md-button
                                                    :to="{
                                                        name: 'collection',
                                                        params: { id: item.id }
                                                    }"
                                                >
                                                    <md-icon>create</md-icon>
                                                    <span>Editar</span>
                                                </md-button>
                                            </md-table-cell>
                                        </md-table-row>
                                    </md-table>
                                </div>
                            </div>
                        </md-card-content>
                    </md-card-area>
                </md-card>
            </div>
        </div>
    </div>
</template>

<script>
import axios from "axios";
const toLower = text => {
    return text.toString().toLowerCase();
};

const searchByName = (items, term) => {
    if (term) {
        return items.filter(item =>
            toLower(item.label).includes(toLower(term))
        );
    }

    return items;
};

export default {
    name: "collections",
    data() {
        return {
            endPoint: "/api/collection",
            collections: [],
            searched: [],
            search: ""
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        }
    },
    methods: {
        searchOnTable() {
            this.searched = searchByName(this.collections, this.search);
        },

        getCollections() {
            axios
                .get(this.endPoint)
                .then(res => {
                    if (res && res.data) {
                        this.collections = res.data.data;
                        this.searched = this.collections;
                    } else {
                        this.collections = [];
                    }
                })
                .catch(error => {
                    console.log("Error getCollections" + error);
                });
        }
    },
    mounted() {
        this.getCollections();
    }
};
</script>
